apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "nlx-keycloak.fullname" . }}
  labels:
    {{- include "nlx-keycloak.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "nlx-keycloak.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "nlx-keycloak.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.image.pullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "nlx-keycloak.serviceAccountName" . }}
      containers:
        - name: keycloak
          image: {{ template "nlx-keycloak.image" . }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          args: ["start", "--optimized"]
          env:
            - name: KEYCLOAK_ADMIN
              value: {{ .Values.config.adminUsername}}
            - name: KEYCLOAK_ADMIN_PASSWORD
              value: {{ .Values.config.adminPassword}}
            - name: KC_HOSTNAME_URL
              value: {{ .Values.config.keycloakHostURL }}
            - name: KC_HOSTNAME_ADMIN_URL
              value: {{ .Values.config.keycloakHostAdminURL }}
            - name: JAVA_OPTS_KC_HEAP
              value: {{ .Values.config.javaOptsHeap }}
          {{- if .Values.extraEnv }}
            {{- toYaml .Values.extraEnv | nindent 12 }}
          {{- end }}
          ports:
            - name: http
              containerPort: 8080
          readinessProbe:
            httpGet:
              path: /health/ready
              port: 8080
            initialDelaySeconds: 3
            periodSeconds: 10
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
